Ball = class("Ball")

function Ball:initialize(x,y,vx,vy,r)
self.x = x
self.y = y
self.vx = vx
self.vy = vy
self.attempted = false
self.fillMode = "line"
	if r == nil then
		self.radius = 16
	else
		self.radius = r
	end
-- self.segments = math.random(1,16)*4
end 

function Ball:setColor(colorType,colorID)
	if colorType == "Table" then
		self.colorID = colorID
		self.r = Color[colorID].R
		self.g = Color[colorID].G
		self.b = Color[colorID].B
	end
	if colorType == "Threshold" then
		if colorID == nil then
			self.r = (math.random(1,8)*32)-1
			self.g = (math.random(1,8)*32)-1
			self.b = (math.random(1,8)*32)-1
		else
			self.r = (math.random(1,256/colorID)*colorID)-1
			self.g = (math.random(1,256/colorID)*colorID)-1
			self.b = (math.random(1,256/colorID)*colorID)-1
		end
	end
	if colorType == "Full" then
			self.r = math.random(1,256)
			self.g = math.random(1,256)
			self.b = math.random(1,256)
	end
end

function Ball:update()
self:checkWalls()
self.x = self.x + self.vx
self.y = self.y + self.vy
	if love.keyboard.isDown("z") then
		if distanceFrom(mx,my,self.x,self.y)<self.radius then
		self.fillMode = "line"
		else
		self.fillMode = "fill"
		end
	else
		if distanceFrom(mx,my,self.x,self.y)<self.radius then
		self.fillMode = "fill"
		else
		self.fillMode = "line"
		end
	end
end

function Ball:draw()	
	if Game.stippling == true then
		if self.attempted == true then
			love.graphics.setLineStipple(0xAAAA,4 )
			-- love.graphics.setLineStipple(0xFFFF,4 )
		else
			love.graphics.setLineStipple(0xFFFF,4 )
			-- love.graphics.setLineStipple(0xFFFF,4 )
		end
	end
	love.graphics.setColor(self.r, self.g,self.b)
	love.graphics.circle(self.fillMode,self.x, self.y,self.radius,32)
	-- love.graphics.setColor(128,32,32)
	-- love.graphics.print(n .. "," .. gameBall[n].colorID,gameBall[n].x, gameBall[n].y)
end

function Ball:checkWalls()
	-- if self.x+self.radius>Game.width then
	if self.x>Game.width then
	self.vx = -self.vx
	end
	if self.x<0 then
	self.vx = -self.vx
	end
	-- if self.y+self.radius>Game.height then
	if self.y>Game.height then
	self.vy = -self.vy
	end
	if self.y<0 then
	self.vy = -self.vy
	end
end

function Ball:checkBallCollision(ball2)
local radiusSum = self.radius + gameBall[ball2].radius
	if distanceFrom(self.x,self.y, gameBall[ball2].x,gameBall[ball2].y)<radiusSum  then
		-- self.vx = -self.vx
		-- self.vy = -self.vy
		-- self.strobe = true
		-- local colorToBeUsed = math.random(1,#Color)
	-- self:setColor(colorToBeUsed)
	end
end

