local  Play = Game:addState("Play")

function Play:enterState()
	if Game.started == false then

	Game.colorSet = Game.modeSelectNames[Game.modeSelect]
	love.graphics.setFont(menuFont)
	love.keyboard.setKeyRepeat(10,50)
	love.mouse.setVisible(false)
	love.mouse.setGrab(true)
	math.randomseed(os.time())
	goalColor = {}
	local circleAmount = round((Game.width/128)*(Game.height/128),0)
	gameBall = {}
		for n=1,circleAmount do
			local randomVX = math.random(-20,20)/10
			local randomVY = math.random(-20,20)/10
			local radiusNew = math.random(2,8)*8
			local newX = math.random(radiusNew,Game.width-radiusNew)
			local newY = math.random(radiusNew,Game.height-radiusNew)	
			gameBall[n] = Ball:new(newX,newY,randomVX,randomVY,radiusNew)	
			if Game.colorSet == "Named Set-137" then
				local colorToBeUsed = math.random(1,#Color)
				gameBall[n]:setColor("Table",colorToBeUsed)
			elseif Game.colorSet == "Full" then
				gameBall[n]:setColor("Full")
			elseif Game.colorSet == "32K" then
				gameBall[n]:setColor("Threshold",8)
			elseif Game.colorSet == "4096" then
				gameBall[n]:setColor("Threshold",16)			
			elseif Game.colorSet == "512" then
				gameBall[n]:setColor("Threshold",32)
			elseif Game.colorSet == "64" then
				gameBall[n]:setColor("Threshold",64)
			end
		end
	-- gameBall[1]
	newGoalColor()
	gameOver = false
	startTime = os.time()
	Game.started = true
	end
end

function Play:update()
checkBalls()
	for n=1,#gameBall do
		gameBall[n]:update()
	end
end

function Play:draw()
love.graphics.setColor(goalColor.red,goalColor.green,goalColor.blue)
love.graphics.setBlendMode("alpha")
love.graphics.setLine(16,"smooth")
love.graphics.rectangle("line",0,0,Game.width,Game.height)
-- love.graphics.setBlendMode("additive")
love.graphics.setLine(3,"smooth")
love.graphics.setLineStipple(0xAAAA,4 )
love.graphics.setColor(goalColor.red,goalColor.green,goalColor.blue,64)
	for n=1, Game.width/128 do
		for m=1, Game.height/128 do
			love.graphics.line(n*128,-2,n*128,Game.height)
			love.graphics.line(-2,m*128,Game.width,m*128)
		end
	end
love.graphics.setLine(1,"smooth")
love.graphics.setLineStipple(0xAAAA,8 )
love.graphics.setColor(goalColor.red,goalColor.green,goalColor.blue,64)
	for n=1, Game.width/128 do
		for m=1, Game.height/128 do
			love.graphics.line(n*128,-2,n*128,Game.height)
			love.graphics.line(-2,m*128,Game.width,m*128)
		end
	end
	if gameOver == true then
	love.graphics.setColor(255,255,255)
	love.graphics.printf(gameTime,0,Game.height/2,Game.width,"center")
	else

 
	love.graphics.setLineStipple(0xFFFF,4 )
	love.graphics.setBlendMode("alpha")
	love.graphics.setLine(2,"smooth")
		for n=1, #gameBall do
			gameBall[n]:draw()
		end
		love.graphics.setLineStipple(0xFFFF,4 )
	love.graphics.setColor(128,32,32)
	love.graphics.circle("fill",mx,my,8,4)			
	love.graphics.setBlendMode("alpha")


	-- love.graphics.draw(cursor,mx,my,0.5,.5
	end
end

function Play:keypressed(key)
	if key == "escape" then
		Game:gotoState('Menu')
	end
		for n=1, #gameBall do
		if distanceFrom(mx,my,gameBall[n].x,gameBall[n].y)<gameBall[n].radius then
			
			if gameBall[n].r == goalColor.red and 
			gameBall[n].g == goalColor.green and 
			gameBall[n].b == goalColor.blue then
				if #gameBall == 1 then
				endGame()
				else
				Shiftup(gameBall, n)
				newGoalColor()
				break
				end
			end
		end
	end
end

function Play:exitState()

end

function Play:mousepressed()
	for n=1, #gameBall do
		if distanceFrom(mx,my,gameBall[n].x,gameBall[n].y)<gameBall[n].radius then
		gameBall[n].attempted = true
			if gameBall[n].r == goalColor.red and 
			gameBall[n].g == goalColor.green and 
			gameBall[n].b == goalColor.blue then
				if #gameBall == 1 then
				endGame()
				else
				Shiftup(gameBall, n)
				unStippleAll()
				newGoalColor()
				break
				end
			end
		end
	end
end

function newGoalColor()
	local newColor = math.random(1,#gameBall)
	goalColor = { red = gameBall[newColor].r,
	green = gameBall[newColor].g,
	blue = gameBall[newColor].b,
	}
end

function endGame()
endTime = os.time()
gameTime = os.difftime(endTime,startTime)
gameOver = true
Game.started = false
end

function unStippleAll()
	for n=1,#gameBall do
		gameBall[n].attempted = false
	end
end

function checkBalls()

	for n=1, #gameBall-1 do
		for m=n+1,#gameBall do
			gameBall[n]:checkBallCollision(m)
		end
	end	
end


